// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: upsert_failed_contract_distribution.sql

package queries

import (
	"context"

	"github.com/jackc/pgx/v5/pgtype"
)

const upsertFailedContractDistribution = `-- name: UpsertFailedContractDistribution :exec

insert into
    contracts.failed_distributions
(
    peer_id,
    content_hash,
    action,
    signature,
    next_attempt_at,
    reason,
    attempts,
    last_attempt_at
) values (
    $1,
    $2,
    $3,
    $4,
    $5,
    $6,
    $7,
    $8
) on conflict (
    peer_id,
    content_hash,
    action
) do update set
    signature = excluded.signature,
    next_attempt_at = excluded.next_attempt_at,
    reason = excluded.reason,
    attempts = excluded.attempts,
    last_attempt_at = excluded.last_attempt_at
`

type UpsertFailedContractDistributionParams struct {
	PeerID        string
	ContentHash   string
	Action        ContractsDistributionAction
	Signature     string
	NextAttemptAt pgtype.Timestamptz
	Reason        string
	Attempts      int32
	LastAttemptAt pgtype.Timestamptz
}

// Copyright © VNG Realisatie 2024
// Licensed under the EUPL
func (q *Queries) UpsertFailedContractDistribution(ctx context.Context, arg *UpsertFailedContractDistributionParams) error {
	_, err := q.db.Exec(ctx, upsertFailedContractDistribution,
		arg.PeerID,
		arg.ContentHash,
		arg.Action,
		arg.Signature,
		arg.NextAttemptAt,
		arg.Reason,
		arg.Attempts,
		arg.LastAttemptAt,
	)
	return err
}
